/*
 * =====================================================================================
 *
 *       Filename:  main.c
 *
 *    Description:  
 *
 *        Version:  1.0.0
 *        Created:  2010.4.16
 *       Revision:  none
 *       Compiler:  Nios II 9.0 IDE
 *
 *         Author:   (AVIC)
 *          Email:  avic633@gmail.com  
 *             QQ:  984597569
 *            URL:  http://kingst.cnblogs.com
 *
 * =====================================================================================
 */

/*-----------------------------------------------------------------------------
 *  Include
 *-----------------------------------------------------------------------------*/
#include <stdio.h>
#include <sys/unistd.h>
#include <io.h>
#include <string.h>

#include "system.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_timer_regs.h"
#include "alt_types.h"
#include "sys/alt_irq.h"
#include "../inc/sopc.h"

/*-----------------------------------------------------------------------------
 *  Variable
 *-----------------------------------------------------------------------------*/
static void timer_init(void);    //ʼж

int i = 0,j = 0,flag;
//0.05s 0.1s 0.5s 1s
alt_u32 timer_prd[4] = {5000000, 10000000, 50000000, 100000000};//ʱ

//xĵλs
//0.5 PERIOD(0.5) = 100 000 000 * 0.5 = 50 000 000
#define PERIOD(x)   ALT_CPU_FREQ * (x)
/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  main
 *  Description:  
 * =====================================================================================
 */
int main(void)
{
    //ʼTimer
    timer_init();

    while(1);

    return 0;
}

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  ISR_timer
 *  Description:  
 * =====================================================================================
 */
static void ISR_timer1(void *context, alt_u32 id)
{  
    //ˮ˸һĸLED
    LED->DATA = 1<<i;

    i++;

    if(i == 4)
        i = 0;    

    //Timerжϱ־Ĵ
    IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER1_BASE, 0x00);
}

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  ISR_timer2
 *  Description:  ͨʱ2ı䶨ʱ1ڣıҪʱ
 * =====================================================================================
 */
static void ISR_timer2(void *context, alt_u32 id)
{
    //ı䶨ʱ1
    IOWR_ALTERA_AVALON_TIMER_PERIODL(TIMER1_BASE, timer_prd[j]);
    IOWR_ALTERA_AVALON_TIMER_PERIODH(TIMER1_BASE, timer_prd[j] >> 16);  

    //ʱ
    IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER1_BASE, 0x07); 

    //˸ƵȸߺȻֱ
    if(j == 0)
        flag = 0;
    if(j == 3)
        flag = 1;

    if(flag == 0){
        j++;
    }
    else{
        j--;
    }

    //жϱ־λ
    IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER2_BASE, 0);  
}

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  timer_init
 *  Description:  
 * =====================================================================================
 */
void timer_init(void)    //ʼж
{
    //Timer1жϱ־Ĵ
    IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER1_BASE, 0x00);
    //Timer1 
    unsigned int p = PERIOD(0.8); //0.8s
    IOWR_ALTERA_AVALON_TIMER_PERIODL(TIMER1_BASE,p);
    IOWR_ALTERA_AVALON_TIMER_PERIODH(TIMER1_BASE, p >> 16);
    //Timer1ж
    IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER1_BASE, 0x07); //0000 0111    
    //עTimer1ж
    alt_irq_register(TIMER1_IRQ, (void *)TIMER1_BASE, ISR_timer1);  

    //Timer2жϱ־Ĵ
    IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER2_BASE, 0x00);
    //Timer2
    unsigned int q = PERIOD(4); 
    IOWR_ALTERA_AVALON_TIMER_PERIODL(TIMER2_BASE,q);//4s
    IOWR_ALTERA_AVALON_TIMER_PERIODH(TIMER2_BASE, q >> 16);
    //Timer2ж
    IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER2_BASE, 0x07);
    //עTimer2ж
    alt_irq_register(TIMER2_IRQ, (void *)TIMER2_BASE, ISR_timer2); 
}

